diff --git a/include/qom/object.h b/include/qom/object.h
index d0dafe9..3e7e99d 100644
--- a/include/qom/object.h
+++ b/include/qom/object.h
@@ -18,10 +18,9 @@
 #include <stdint.h>
 #include <stdbool.h>
 #include "qemu/queue.h"
+#include "qemu/typedefs.h"
 #include "qapi/error.h"

-struct Visitor;
-
 struct TypeImpl;
 typedef struct TypeImpl *Type;

@@ -298,7 +297,7 @@ typedef struct InterfaceInfo InterfaceInfo;
  * Called when trying to get/set a property.
  */
 typedef void (ObjectPropertyAccessor)(Object *obj,
-                                      struct Visitor *v,
+                                      Visitor *v,
                                       void *opaque,
                                       const char *name,
                                       Error **errp);
@@ -1025,7 +1024,7 @@ void object_unparent(Object *obj);
  *
  * Reads a property from a object.
  */
-void object_property_get(Object *obj, struct Visitor *v, const char *name,
+void object_property_get(Object *obj, Visitor *v, const char *name,
                          Error **errp);

 /**
@@ -1161,7 +1160,7 @@ void object_property_get_uint16List(Object *obj, const char *name,
  *
  * Writes a property to a object.
  */
-void object_property_set(Object *obj, struct Visitor *v, const char *name,
+void object_property_set(Object *obj, Visitor *v, const char *name,
                          Error **errp);

 /**
diff --git a/hw/misc/edu.c b/hw/misc/edu.c
index 43d5b18..a7171eb 100644
--- a/hw/misc/edu.c
+++ b/hw/misc/edu.c
@@ -362,8 +362,8 @@ static void pci_edu_uninit(PCIDevice *pdev)
     timer_del(&edu->dma_timer);
 }

-static void edu_obj_uint64(Object *obj, struct Visitor *v, void *opaque,
-                const char *name, Error **errp)
+static void edu_obj_uint64(Object *obj, Visitor *v, void *opaque,
+                           const char *name, Error **errp)
 {
     uint64_t *val = opaque;

diff --git a/hw/virtio/virtio-balloon.c b/hw/virtio/virtio-balloon.c
index ba1d393..02e2bb9 100644
--- a/hw/virtio/virtio-balloon.c
+++ b/hw/virtio/virtio-balloon.c
@@ -110,7 +110,7 @@ static void balloon_stats_poll_cb(void *opaque)
     virtio_notify(vdev, s->svq);
 }

-static void balloon_stats_get_all(Object *obj, struct Visitor *v,
+static void balloon_stats_get_all(Object *obj, Visitor *v,
                                   void *opaque, const char *name, Error **errp)
 {
     Error *err = NULL;
@@ -148,7 +148,7 @@ out:
     error_propagate(errp, err);
 }

-static void balloon_stats_get_poll_interval(Object *obj, struct Visitor *v,
+static void balloon_stats_get_poll_interval(Object *obj, Visitor *v,
                                             void *opaque, const char *name,
                                             Error **errp)
 {
@@ -156,7 +156,7 @@ static void balloon_stats_get_poll_interval(Object *obj, struct Visitor *v,
     visit_type_int(v, &s->stats_poll_interval, name, errp);
 }

-static void balloon_stats_set_poll_interval(Object *obj, struct Visitor *v,
+static void balloon_stats_set_poll_interval(Object *obj, Visitor *v,
                                             void *opaque, const char *name,
                                             Error **errp)
 {
diff --git a/qom/object.c b/qom/object.c
index 5ff97ab..4d7d8c8 100644
--- a/qom/object.c
+++ b/qom/object.c
@@ -2184,7 +2184,7 @@ typedef struct {
     char *target_name;
 } AliasProperty;

-static void property_get_alias(Object *obj, struct Visitor *v, void *opaque,
+static void property_get_alias(Object *obj, Visitor *v, void *opaque,
                                const char *name, Error **errp)
 {
     AliasProperty *prop = opaque;
@@ -2192,7 +2192,7 @@ static void property_get_alias(Object *obj, struct Visitor *v, void *opaque,
     object_property_get(prop->target_obj, v, prop->target_name, errp);
 }

-static void property_set_alias(Object *obj, struct Visitor *v, void *opaque,
+static void property_set_alias(Object *obj, Visitor *v, void *opaque,
                                const char *name, Error **errp)
 {
     AliasProperty *prop = opaque;
diff --git a/target-i386/cpu.c b/target-i386/cpu.c
index b255644..60bfa80 100644
--- a/target-i386/cpu.c
+++ b/target-i386/cpu.c
@@ -2945,7 +2945,7 @@ typedef struct BitProperty {
 } BitProperty;

 static void x86_cpu_get_bit_prop(Object *obj,
-                                 struct Visitor *v,
+                                 Visitor *v,
                                  void *opaque,
                                  const char *name,
                                  Error **errp)
@@ -2956,7 +2956,7 @@ static void x86_cpu_get_bit_prop(Object *obj,
 }

 static void x86_cpu_set_bit_prop(Object *obj,
-                                 struct Visitor *v,
+                                 Visitor *v,
                                  void *opaque,
                                  const char *name,
                                  Error **errp)